bug-diffutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[bug-diffutils] FYI, 10 change sets


From: Jim Meyering
Subject: [bug-diffutils] FYI, 10 change sets
Date: Wed, 18 Nov 2009 08:03:23 +0100

Nothing big or invasive...


Eric Blake (1):
      build: avoid link failure when libsigsegv is used

Jim Meyering (9):
      tests: add the first script; hook up gnulib-tests
      sdiff, diff3: exec diff, not $(bindir)/diff
      maint: address@hidden is the new bug-reporting address
      maint: no longer define *_FILENO constants
      maint: define/use PROGRAM_NAME and AUTHORS; use propername module
      admin: ignore all of gnulib-tests
      build: let automake generate better man-installation rules
      maint: hide build commands behind $(AM_V_GEN)
      build: update gnulib submodule to latest


>From e454c1471aaf8b3e6bead2313838aefebfe97bca Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Sat, 14 Nov 2009 10:31:41 +0100
Subject: [PATCH 01/10] tests: add the first script; hook up gnulib-tests

* configure.ac (AC_CONFIG_FILES): Add tests/Makefile and
gnulib-tests/Makefile.
* tests/help-version: New file, from coreutils.
* tests/test-lib.sh: Likewise.
* tests/Makefile.am: New file, from gzip.
* Makefile.am (SUBDIRS): Add tests and gnulib-tests.
* tests/t-local.sh: New, empty(for now) file.
---
 .gitignore         |    2 +
 Makefile.am        |    2 +-
 configure.ac       |   13 ++-
 tests/Makefile.am  |   54 +++++++
 tests/help-version |  211 +++++++++++++++++++++++++++
 tests/test-lib.sh  |  408 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 6 files changed, 686 insertions(+), 4 deletions(-)
 create mode 100644 tests/Makefile.am
 create mode 100755 tests/help-version
 create mode 100644 tests/t-local.sh
 create mode 100644 tests/test-lib.sh

diff --git a/.gitignore b/.gitignore
index e0f99dd..78b4daa 100644
--- a/.gitignore
+++ b/.gitignore
@@ -41,6 +41,7 @@ Makefile
 Makefile.in
 autom4te.cache
 build-aux
+gnulib-tests/*.log
 man/*.1
 po/*.gmo
 po/*.po
@@ -49,3 +50,4 @@ src/diff
 src/diff3
 src/paths.h
 src/sdiff
+tests/*.log
diff --git a/Makefile.am b/Makefile.am
index ec51c32..be74dae 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -17,7 +17,7 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.

 EXTRA_DIST = bootstrap exgettext ChangeLog-2008
-SUBDIRS = lib ms src doc man po
+SUBDIRS = lib src tests doc man po ms gnulib-tests

 ACLOCAL_AMFLAGS = -I m4

diff --git a/configure.ac b/configure.ac
index 05000e2..697bb27 100644
--- a/configure.ac
+++ b/configure.ac
@@ -67,7 +67,14 @@ AM_GNU_GETTEXT([external], [need-ngettext])
 AM_GNU_GETTEXT_VERSION([0.17])
 XGETTEXT="AWK='$AWK' \$(SHELL) \$(top_srcdir)/exgettext $XGETTEXT"

-AC_CONFIG_FILES([Makefile doc/Makefile \
-                lib/Makefile man/Makefile \
-                ms/Makefile po/Makefile.in src/Makefile])
+AC_CONFIG_FILES([
+  Makefile doc/Makefile
+  lib/Makefile
+  src/Makefile
+  tests/Makefile
+  gnulib-tests/Makefile
+  man/Makefile
+  po/Makefile.in
+  ms/Makefile
+])
 AC_OUTPUT
diff --git a/tests/Makefile.am b/tests/Makefile.am
new file mode 100644
index 0000000..daec940
--- /dev/null
+++ b/tests/Makefile.am
@@ -0,0 +1,54 @@
+TESTS = \
+  help-version
+
+EXTRA_DIST = \
+  $(TESTS) test-lib.sh t-local.sh
+
+# Note that the first lines are statements.  They ensure that environment
+# variables that can perturb tests are unset or set to expected values.
+# The rest are envvar settings that propagate build-related Makefile
+# variables to test scripts.
+TESTS_ENVIRONMENT =                            \
+  tmp__=$$TMPDIR; test -d "$$tmp__" || tmp__=.;        \
+  TMPDIR=$$tmp__; export TMPDIR;               \
+  exec 9>&2;                                   \
+  shell_or_perl_() {                           \
+    if grep '^\#!/usr/bin/perl' "$$1" > /dev/null; then                        
\
+      if $(PERL) -e 'use warnings' > /dev/null 2>&1; then              \
+       grep '^\#!/usr/bin/perl -T' "$$1" > /dev/null && T_=T || T_=;   \
+        $(PERL) -w$$T_ -I$(srcdir) -MCoreutils                         \
+             -M"CuTmpdir qw($$f)" -- "$$1";    \
+      else                                     \
+       echo 1>&2 "$$tst: configure did not find a usable version of Perl," \
+         "so skipping this test";              \
+       (exit 77);                              \
+      fi;                                      \
+    else                                       \
+      $(SHELL) "$$1";                          \
+    fi;                                                \
+  };                                           \
+  export                                       \
+  abs_top_builddir='$(abs_top_builddir)'       \
+  abs_top_srcdir='$(abs_top_srcdir)'           \
+  abs_srcdir='$(abs_srcdir)'                   \
+  built_programs="`$(built_programs)`"         \
+  srcdir='$(srcdir)'                           \
+  top_srcdir='$(top_srcdir)'                   \
+  CC='$(CC)'                                   \
+  MAKE=$(MAKE)                                 \
+  PACKAGE_BUGREPORT='$(PACKAGE_BUGREPORT)'     \
+  PACKAGE_VERSION=$(PACKAGE_VERSION)           \
+  CONFIG_HEADER='$(abs_top_builddir)/lib/config.h' \
+  ENABLE_DEVICE_MAPPER=$(ENABLE_DEVICE_MAPPER) \
+  PERL='$(PERL)'                               \
+  PREFERABLY_POSIX_SHELL='$(PREFERABLY_POSIX_SHELL)' \
+  REPLACE_GETCWD=$(REPLACE_GETCWD)             \
+  PATH='$(abs_top_builddir)/src$(PATH_SEPARATOR)'"$$PATH" \
+  ; shell_or_perl_
+
+built_programs =                                                       \
+  echo 'spy:;@echo $$(PROGRAMS)'                                       \
+    | MAKEFLAGS= $(MAKE) -s -C $(builddir)/../src -f Makefile -f - spy \
+    | fmt -1 | sort -u
+
+VERBOSE = yes
diff --git a/tests/help-version b/tests/help-version
new file mode 100755
index 0000000..2ab0865
--- /dev/null
+++ b/tests/help-version
@@ -0,0 +1,211 @@
+#! /bin/sh
+# Make sure all these programs work properly
+# when invoked with --help or --version.
+
+# Copyright (C) 2000-2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+test "$VERBOSE" = yes && set -x
+
+# Ensure that $SHELL is set to *some* value and exported.
+# This is required for dircolors, which would fail e.g., when
+# invoked via debuild (which removes SHELL from the environment).
+test "x$SHELL" = x && SHELL=/bin/sh
+export SHELL
+
+. $srcdir/test-lib.sh
+
+expected_failure_status_chroot=125
+expected_failure_status_env=125
+expected_failure_status_nice=125
+expected_failure_status_nohup=125
+expected_failure_status_stdbuf=125
+expected_failure_status_su=125
+expected_failure_status_timeout=125
+expected_failure_status_printenv=2
+expected_failure_status_tty=3
+expected_failure_status_sort=2
+expected_failure_status_expr=3
+expected_failure_status_lbracket=2
+expected_failure_status_dir=2
+expected_failure_status_ls=2
+expected_failure_status_vdir=2
+
+expected_failure_status_cmp=2
+expected_failure_status_sdiff=2
+expected_failure_status_diff3=2
+expected_failure_status_diff=2
+
+test "$built_programs" \
+  || { echo "$this_test: no programs built!?!" 1>&2; Exit 1; }
+
+for lang in C fr da; do
+  for i in $built_programs; do
+
+    # Skip `test'; it doesn't accept --help or --version.
+    test $i = test && continue;
+
+    # false fails even when invoked with --help or --version.
+    if test $i = false; then
+      env LC_MESSAGES=$lang $i --help >/dev/null && fail=1
+      env LC_MESSAGES=$lang $i --version >/dev/null && fail=1
+      continue
+    fi
+
+    # The just-built install executable is always named `ginstall'.
+    test $i = install && i=ginstall
+
+    # Make sure they exit successfully, under normal conditions.
+    env $i --help    > h-$i     || fail=1
+    env $i --version >/dev/null || fail=1
+
+    # Make sure they mention the bug-reporting address in --help output.
+    grep "$PACKAGE_BUGREPORT" h-$i > /dev/null || fail=1
+    rm -f h-$i
+
+    # Make sure they fail upon `disk full' error.
+    if test -w /dev/full && test -c /dev/full; then
+      env $i --help    >/dev/full 2>/dev/null && fail=1
+      env $i --version >/dev/full 2>/dev/null && fail=1
+      status=$?
+      test $i = [ && prog=lbracket || prog=$i
+      eval "expected=\$expected_failure_status_$prog"
+      test x$expected = x && expected=1
+      if test $status = $expected; then
+        : # ok
+      else
+        fail=1
+        echo "*** $i: bad exit status \`$status' (expected $expected)," 1>&2
+        echo "  with --help or --version output redirected to /dev/full" 1>&2
+      fi
+    fi
+  done
+done
+
+tmp=tmp-$$
+tmp_in=in-$$
+tmp_in2=in2-$$
+tmp_dir=dir-$$
+tmp_out=out-$$
+mkdir $tmp || fail=1
+cd $tmp || fail=1
+
+comm_args="$tmp_in $tmp_in"
+csplit_args="$tmp_in //"
+cut_args='-f 1'
+join_args="$tmp_in $tmp_in"
+tr_args='a a'
+
+chmod_args="a+x $tmp_in"
+# Punt on these.
+chgrp_args=--version
+chown_args=--version
+mkfifo_args=--version
+mknod_args=--version
+# Punt on uptime, since it fails (e.g., failing to get boot time)
+# on some systems, and we shouldn't let that stop `make check'.
+uptime_args=--version
+
+# Create a file in the current directory, not in $TMPDIR.
+mktemp_args=mktemp.XXXX
+
+cmp_args="$tmp_in $tmp_in2"
+
+# Tell dd not to print the line with transfer rate and total.
+# The transfer rate would vary between runs.
+dd_args=status=noxfer
+
+diff_args="$tmp_in $tmp_in2"
+sdiff_args="$tmp_in $tmp_in2"
+diff3_args="$tmp_in $tmp_in2 $tmp_in2"
+cp_args="$tmp_in $tmp_in2"
+ln_args="$tmp_in ln-target"
+ginstall_args="$tmp_in $tmp_in2"
+mv_args="$tmp_in $tmp_in2"
+mkdir_args=$tmp_dir/subdir
+rmdir_args=$tmp_dir
+rm_args=$tmp_in
+shred_args=$tmp_in
+touch_args=$tmp_in2
+truncate_args="--reference=$tmp_in $tmp_in2"
+
+basename_args=$tmp_in
+dirname_args=$tmp_in
+expr_args=foo
+
+# Punt, in case GNU `id' hasn't been installed yet.
+groups_args=--version
+
+pathchk_args=$tmp_in
+yes_args=--version
+logname_args=--version
+nohup_args=--version
+printf_args=foo
+seq_args=10
+sleep_args=0
+su_args=--version
+stdbuf_args="-oL true"
+timeout_args=--version
+
+# I'd rather not run sync, since it spins up disks that I've
+# deliberately caused to spin down (but not unmounted).
+sync_args=--version
+
+test_args=foo
+
+# This is necessary in the unusual event that there is
+# no valid entry in /etc/mtab.
+df_args=/
+
+# This is necessary in the unusual event that getpwuid (getuid ()) fails.
+id_args=-u
+
+# Use env to avoid invoking built-in sleep of Solaris 11's /bin/sh.
+env sleep 10m &
+kill_args=$!
+
+link_args="$tmp_in link-target"
+unlink_args=$tmp_in
+
+ln -s . slink
+readlink_args=slink
+
+stat_args=$tmp_in
+unlink_args=$tmp_in
+lbracket_args=": ]"
+
+# Ensure that each program "works" (exits successfully) when doing
+# something more than --help or --version.
+for i in $built_programs; do
+  # Skip these.
+  case $i in chroot|stty|tty|false|chcon|runcon) continue;; esac
+
+  rm -rf $tmp_in $tmp_in2 $tmp_dir $tmp_out
+  echo > $tmp_in
+  echo > $tmp_in2
+  mkdir $tmp_dir
+  # echo ================== $i
+  test $i = [ && prog=lbracket || prog=$i
+  eval "args=\$${prog}_args"
+  if env $i $args < $tmp_in > $tmp_out; then
+    : # ok
+  else
+    echo FAIL: $i
+    fail=1
+  fi
+  rm -rf $tmp_in $tmp_in2 $tmp_out $tmp_dir
+done
+
+Exit $fail
diff --git a/tests/t-local.sh b/tests/t-local.sh
new file mode 100644
index 0000000..e69de29
diff --git a/tests/test-lib.sh b/tests/test-lib.sh
new file mode 100644
index 0000000..b39d06c
--- /dev/null
+++ b/tests/test-lib.sh
@@ -0,0 +1,408 @@
+# source this file; set up for tests
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Skip this test if the shell lacks support for functions.
+unset function_test
+eval 'function_test() { return 11; }; function_test'
+if test $? != 11; then
+  echo "$0: /bin/sh lacks support for functions; skipping this test." 1>&2
+  Exit 77
+fi
+
+skip_test_()
+{
+  echo "$0: skipping test: $@" | head -1 1>&9
+  echo "$0: skipping test: $@" 1>&2
+  Exit 77
+}
+
+getlimits_()
+{
+    eval $(getlimits)
+    test "$INT_MAX" ||
+    error_ "Error running getlimits"
+}
+
+require_acl_()
+{
+  getfacl --version < /dev/null > /dev/null 2>&1 \
+    && setfacl --version < /dev/null > /dev/null 2>&1 \
+      || skip_test_ "This test requires getfacl and setfacl."
+
+  id -u bin > /dev/null 2>&1 \
+    || skip_test_ "This test requires a local user named bin."
+}
+
+# Skip this test if we're not in SELinux "enforcing" mode.
+require_selinux_enforcing_()
+{
+  test "$(getenforce)" = Enforcing \
+    || skip_test_ "This test is useful only with SELinux in Enforcing mode."
+}
+
+
+require_openat_support_()
+{
+  # Skip this test if your system has neither the openat-style functions
+  # nor /proc/self/fd support with which to emulate them.
+  test -z "$CONFIG_HEADER" \
+    && skip_test_ 'internal error: CONFIG_HEADER not defined'
+
+  _skip=yes
+  grep '^#define HAVE_OPENAT' "$CONFIG_HEADER" > /dev/null && _skip=no
+  test -d /proc/self/fd && _skip=no
+  if test $_skip = yes; then
+    skip_test_ 'this system lacks openat support'
+  fi
+}
+
+require_ulimit_()
+{
+  ulimit_works=yes
+  # Expect to be able to exec a program in 10MB of virtual memory,
+  # but not in 20KB.  I chose "date".  It must not be a shell built-in
+  # function, so you can't use echo, printf, true, etc.
+  # Of course, in coreutils, I could use $top_builddir/src/true,
+  # but this should be able to work for other projects, too.
+  ( ulimit -v 10000; date ) > /dev/null 2>&1 || ulimit_works=no
+  ( ulimit -v 20;    date ) > /dev/null 2>&1 && ulimit_works=no
+
+  test $ulimit_works = no \
+    && skip_test_ "this shell lacks ulimit support"
+}
+
+require_readable_root_()
+{
+  test -r / || skip_test_ "/ is not readable"
+}
+
+# Skip the current test if strace is not available or doesn't work
+# with the named syscall.  Usage: require_strace_ unlink
+require_strace_()
+{
+  test $# = 1 || framework_failure
+
+  strace -V < /dev/null > /dev/null 2>&1 ||
+    skip_test_ 'no strace program'
+
+  strace -qe "$1" echo > /dev/null 2>&1 ||
+    skip_test_ 'strace -qe "'"$1"'" does not work'
+}
+
+# Require a controlling input `terminal'.
+require_controlling_input_terminal_()
+{
+  tty -s || have_input_tty=no
+  test -t 0 || have_input_tty=no
+  if test "$have_input_tty" = no; then
+    skip_test_ 'requires controlling input terminal
+This test must have a controlling input "terminal", so it may not be
+run via "batch", "at", or "ssh".  On some systems, it may not even be
+run in the background.'
+  fi
+}
+
+require_built_()
+{
+  skip_=no
+  for i in "$@"; do
+    case " $built_programs " in
+      *" $i "*) ;;
+      *) echo "$i: not built" 1>&2; skip_=yes ;;
+    esac
+  done
+
+  test $skip_ = yes && skip_test_ "required program(s) not built"
+}
+
+uid_is_privileged_()
+{
+  # Make sure id -u succeeds.
+  my_uid=$(id -u) \
+    || { echo "$0: cannot run \`id -u'" 1>&2; return 1; }
+
+  # Make sure it gives valid output.
+  case $my_uid in
+    0) ;;
+    *[!0-9]*)
+      echo "$0: invalid output (\`$my_uid') from \`id -u'" 1>&2
+      return 1 ;;
+    *) return 1 ;;
+  esac
+}
+
+get_process_status_()
+{
+  sed -n '/^State:[     ]*\([[:alpha:]]\).*/s//\1/p' /proc/$1/status
+}
+
+# Convert an ls-style permission string, like drwxr----x and -rw-r-x-wx
+# to the equivalent chmod --mode (-m) argument, (=,u=rwx,g=r,o=x and
+# =,u=rw,g=rx,o=wx).  Ignore ACLs.
+rwx_to_mode_()
+{
+  case $# in
+    1) rwx=$1;;
+    *) echo "$0: wrong number of arguments" 1>&2
+      echo "Usage: $0 ls-style-mode-string" 1>&2
+      return;;
+  esac
+
+  case $rwx in
+    [ld-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxtT-]) ;;
+    [ld-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxtT-][+.]) ;;
+    *) echo "$0: invalid mode string: $rwx" 1>&2; return;;
+  esac
+
+  # Perform these conversions:
+  # S  s
+  # s  xs
+  # T  t
+  # t  xt
+  # The `T' and `t' ones are only valid for `other'.
+  s='s/S/@/;s/s/x@/;s/@/s/'
+  t='s/T/@/;s/t/x@/;s/@/t/'
+
+  u=`echo $rwx|sed 's/^.\(...\).*/,u=\1/;s/-//g;s/^,u=$//;'$s`
+  g=`echo $rwx|sed 's/^....\(...\).*/,g=\1/;s/-//g;s/^,g=$//;'$s`
+  o=`echo $rwx|sed 's/^.......\(...\).*/,o=\1/;s/-//g;s/^,o=$//;'$s';'$t`
+  echo "=$u$g$o"
+}
+
+skip_if_()
+{
+  case $1 in
+    root) skip_test_ must be run as root ;;
+    non-root) skip_test_ must be run as non-root ;;
+    *) ;;  # FIXME?
+  esac
+}
+
+require_selinux_()
+{
+  case `ls -Zd .` in
+    '? .'|'unlabeled .')
+      skip_test_ "this system (or maybe just" \
+        "the current file system) lacks SELinux support"
+    ;;
+  esac
+}
+
+very_expensive_()
+{
+  if test "$RUN_VERY_EXPENSIVE_TESTS" != yes; then
+    skip_test_ 'very expensive: disabled by default
+This test is very expensive, so it is disabled by default.
+To run it anyway, rerun make check with the RUN_VERY_EXPENSIVE_TESTS
+environment variable set to yes.  E.g.,
+
+  env RUN_VERY_EXPENSIVE_TESTS=yes make check
+'
+  fi
+}
+
+expensive_()
+{
+  if test "$RUN_EXPENSIVE_TESTS" != yes; then
+    skip_test_ 'expensive: disabled by default
+This test is relatively expensive, so it is disabled by default.
+To run it anyway, rerun make check with the RUN_EXPENSIVE_TESTS
+environment variable set to yes.  E.g.,
+
+  env RUN_EXPENSIVE_TESTS=yes make check
+'
+  fi
+}
+
+require_root_()
+{
+  uid_is_privileged_ || skip_test_ "must be run as root"
+  NON_ROOT_USERNAME=${NON_ROOT_USERNAME=nobody}
+  NON_ROOT_GROUP=${NON_ROOT_GROUP=$(id -g $NON_ROOT_USERNAME)}
+}
+
+skip_if_root_() { uid_is_privileged_ && skip_test_ "must be run as non-root"; }
+error_() { echo "$0: $@" 1>&2; Exit 1; }
+framework_failure() { error_ 'failure in testing framework'; }
+
+# Set `groups' to a space-separated list of at least two groups
+# of which the user is a member.
+require_membership_in_two_groups_()
+{
+  test $# = 0 || framework_failure
+
+  groups=${COREUTILS_GROUPS-`(id -G || /usr/xpg4/bin/id -G) 2>/dev/null`}
+  case "$groups" in
+    *' '*) ;;
+    *) skip_test_ 'requires membership in two groups
+this test requires that you be a member of more than one group,
+but running `id -G'\'' either failed or found just one.  If you really
+are a member of at least two groups, then rerun this test with
+COREUTILS_GROUPS set in your environment to the space-separated list
+of group names or numbers.  E.g.,
+
+  env COREUTILS_GROUPS='users cdrom' make check
+
+'
+     ;;
+  esac
+}
+
+# Is /proc/$PID/status supported?
+require_proc_pid_status_()
+{
+    sleep 2 &
+    local pid=$!
+    sleep .5
+    grep '^State:[      ]*[S]' /proc/$pid/status > /dev/null 2>&1 ||
+    skip_test_ "/proc/$pid/status: missing or 'different'"
+    kill $pid
+}
+
+# Does the current (working-dir) file system support sparse files?
+require_sparse_support_()
+{
+  test $# = 0 || framework_failure
+  # Test whether we can create a sparse file.
+  # For example, on Darwin6.5 with a file system of type hfs, it's not 
possible.
+  # NTFS requires 128K before a hole appears in a sparse file.
+  t=sparse.$$
+  dd bs=1 seek=128K of=$t < /dev/null 2> /dev/null
+  set x `du -sk $t`
+  kb_size=$2
+  rm -f $t
+  if test $kb_size -ge 128; then
+    skip_test_ 'this file system does not support sparse files'
+  fi
+}
+
+mkfifo_or_skip_()
+{
+  test $# = 1 || framework_failure
+  if ! mkfifo "$1"; then
+    # Make an exception of this case -- usually we interpret framework-creation
+    # failure as a test failure.  However, in this case, when running on a 
SunOS
+    # system using a disk NFS mounted from OpenBSD, the above fails like this:
+    # mkfifo: cannot make fifo `fifo-10558': Not owner
+    skip_test_ 'NOTICE: unable to create test prerequisites'
+  fi
+}
+
+# Disable the current test if the working directory seems to have
+# the setgid bit set.
+skip_if_setgid_()
+{
+  setgid_tmpdir=setgid-$$
+  (umask 77; mkdir $setgid_tmpdir)
+  perms=$(stat --printf %A $setgid_tmpdir)
+  rmdir $setgid_tmpdir
+  case $perms in
+    drwx------);;
+    drwxr-xr-x);;  # Windows98 + DJGPP 2.03
+    *) skip_test_ 'this directory has the setgid bit set';;
+  esac
+}
+
+skip_if_mcstransd_is_running_()
+{
+  test $# = 0 || framework_failure
+
+  # When mcstransd is running, you'll see only the 3-component
+  # version of file-system context strings.  Detect that,
+  # and if it's running, skip this test.
+  __ctx=$(stat --printf='%C\n' .) || framework_failure
+  case $__ctx in
+    *:*:*:*) ;; # four components is ok
+    *) # anything else probably means mcstransd is running
+        skip_test_ "unexpected context '$__ctx'; turn off mcstransd" ;;
+  esac
+}
+
+# Skip the current test if umask doesn't work as usual.
+# This test should be run in the temporary directory that ends
+# up being removed via the trap commands.
+working_umask_or_skip_()
+{
+  umask 022
+  touch file1 file2
+  chmod 644 file2
+  perms=`ls -l file1 file2 | sed 's/ .*//' | uniq`
+  rm -f file1 file2
+
+  case $perms in
+  *'
+  '*) skip_test_ 'your build directory has unusual umask semantics'
+  esac
+}
+
+# We use a trap below for cleanup.  This requires us to go through
+# hoops to get the right exit status transported through the signal.
+# So use `Exit STATUS' instead of `exit STATUS' inside of the tests.
+# Turn off errexit here so that we don't trip the bug with OSF1/Tru64
+# sh inside this function.
+Exit ()
+{
+  set +e
+  (exit $1)
+  exit $1
+}
+
+test_dir_=$(pwd)
+
+this_test_() { echo "./$0" | sed 's,.*/,,'; }
+this_test=$(this_test_)
+
+# This is a stub function that is run upon trap (upon regular exit and
+# interrupt).  Override it with a per-test function, e.g., to unmount
+# a partition, or to undo any other global state changes.
+cleanup_() { :; }
+
+t_=$(mktemp -d --tmp="$test_dir_" di-$this_test.XXXXXXXXXX)\
+    || error_ "failed to create temporary directory in $test_dir_"
+
+# Eval the following upon cleanup.
+# This is useful if you have more than than one cleanup function,
+# and for encapsulated cleanup functions; append any addition.
+cleanup_eval_=':'
+
+remove_tmp_()
+{
+  __st=$?
+  cleanup_
+  test -n "$cleanup_eval_" && eval "$cleanup_eval_"
+  cd "$test_dir_" && chmod -R u+rwx "$t_" && rm -rf "$t_" && exit $__st
+}
+
+. $srcdir/t-local.sh
+
+# Run each test from within a temporary sub-directory named after the
+# test itself, and arrange to remove it upon exception or normal exit.
+trap remove_tmp_ 0
+trap 'Exit $?' 1 2 13 15
+
+cd "$t_" || error_ "failed to cd to $t_"
+
+if ( diff --version < /dev/null 2>&1 | grep GNU ) 2>&1 > /dev/null; then
+  compare() { diff -u "$@"; }
+elif ( cmp --version < /dev/null 2>&1 | grep GNU ) 2>&1 > /dev/null; then
+  compare() { cmp -s "$@"; }
+else
+  compare() { cmp "$@"; }
+fi
+
+# Initialize; all bourne shell scripts end with "Exit $fail".
+fail=0
--
1.6.5.3.370.g5b5a93


>From 943b8a4383375c4eb197b4e984d5bca89790c5b0 Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 16 Nov 2009 07:38:03 +0100
Subject: [PATCH 02/10] sdiff, diff3: exec diff, not $(bindir)/diff

* src/Makefile.am (paths.h): Emit a definition of DEFAULT_DIFF_PROGRAM
that is simply "diff" (or whatever $(transform) would convert that to,
e.g., "gdiff").  This makes it so that tests can work without first
installing diff, and so that the binaries do not hard-code $(prefix).
* NEWS (Changes in behavior): Mention this.
---
 NEWS            |    5 +++++
 gnulib          |    2 +-
 src/Makefile.am |    2 +-
 3 files changed, 7 insertions(+), 2 deletions(-)

diff --git a/NEWS b/NEWS
index a87f138..fc4996a 100644
--- a/NEWS
+++ b/NEWS
@@ -19,6 +19,11 @@ GNU diffutils NEWS                                    -*- 
outline -*-

   sdiff now understands '1' and '2' as synonyms for 'l' and 'r'.

+** Changes in behavior
+
+  sdiff and diff3 now invoke diff, not $(bindir)/diff
+
+
 * Noteworthy changes in release 2.8.7 (2004-04-13) [stable]

   Version 2.8.7 contains no user-visible changes.
diff --git a/gnulib b/gnulib
index 492960c..6963723 160000
--- a/gnulib
+++ b/gnulib
@@ -1 +1 @@
-Subproject commit 492960c3a5eaaae32cd9d69d6fd5d7fdf96cbb78
+Subproject commit 69637233ce151566c1a861bce77e1ca32305638e
diff --git a/src/Makefile.am b/src/Makefile.am
index 99c011b..00f4f09 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -37,6 +37,6 @@ MOSTLYCLEANFILES = paths.h paths.ht

 cmp.$(OBJEXT) diff3.$(OBJEXT) diff.$(OBJEXT) sdiff.$(OBJEXT): paths.h
 paths.h:
-       (echo '#define DEFAULT_DIFF_PROGRAM "$(bindir)/'`echo diff|sed 
'$(transform)'`'"' && \
+       (echo '#define DEFAULT_DIFF_PROGRAM "'`echo diff|sed '$(transform)'`'"' 
&& \
         echo '#define LOCALEDIR "$(localedir)"') >address@hidden
        mv address@hidden $@
--
1.6.5.3.370.g5b5a93


>From 3850429db6a8582ae5f1d43fb92dd29ee9af261e Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 16 Nov 2009 08:17:35 +0100
Subject: [PATCH 03/10] maint: address@hidden is the new bug-reporting address

* configure.ac (AC_INIT): Use address@hidden, not bug-gnu-utils
as the bug-reporting address.
* NEWS (Administrivia): Mention this.
* src/cmp.c (usage): Remove hard-coded address.
Instead, use gnulib's emit_bug_reporting_address function.
* src/diff.c (usage, option_help_msgid): Likewise.
* src/diff3.c (usage): Likewise.
* src/sdiff.c (usage): Likewise.
---
 NEWS         |    6 ++++++
 configure.ac |    2 +-
 src/cmp.c    |    6 +++---
 src/diff.c   |    3 +--
 src/diff3.c  |    6 +++---
 src/sdiff.c  |    6 +++---
 6 files changed, 17 insertions(+), 12 deletions(-)

diff --git a/NEWS b/NEWS
index fc4996a..6230976 100644
--- a/NEWS
+++ b/NEWS
@@ -23,6 +23,12 @@ GNU diffutils NEWS                                    -*- 
outline -*-

   sdiff and diff3 now invoke diff, not $(bindir)/diff

+** Administrivia
+
+  New discussion and bug-reporting address: address@hidden
+
+  updated gnulib support
+

 * Noteworthy changes in release 2.8.7 (2004-04-13) [stable]

diff --git a/configure.ac b/configure.ac
index 697bb27..b56139c 100644
--- a/configure.ac
+++ b/configure.ac
@@ -20,7 +20,7 @@ AC_PREREQ(2.61)

 AC_INIT([GNU diffutils],
         m4_esyscmd([build-aux/git-version-gen .tarball-version]),
-        address@hidden)
+        address@hidden)

 AC_CONFIG_SRCDIR([src/diff.c])
 AC_CONFIG_AUX_DIR([build-aux])
diff --git a/src/cmp.c b/src/cmp.c
index 9cea036..18056a6 100644
--- a/src/cmp.c
+++ b/src/cmp.c
@@ -172,14 +172,14 @@ usage (void)
   printf ("%s\n\n", _("Compare two files byte by byte."));
   for (p = option_help_msgid;  *p;  p++)
     printf ("  %s\n", _(*p));
-  printf ("\n%s\n%s\n\n%s\n%s\n\n%s\n",
+  printf ("\n%s\n%s\n\n%s\n%s\n",
          _("SKIP1 and SKIP2 are the number of bytes to skip in each file."),
          _("SKIP values may be followed by the following multiplicative 
suffixes:\n\
 kB 1000, K 1024, MB 1,000,000, M 1,048,576,\n\
 GB 1,000,000,000, G 1,073,741,824, and so on for T, P, E, Z, Y."),
          _("If a FILE is `-' or missing, read standard input."),
-         _("Exit status is 0 if inputs are the same, 1 if different, 2 if 
trouble."),
-         _("Report bugs to <address@hidden>."));
+         _("Exit status is 0 if inputs are the same, 1 if different, 2 if 
trouble."));
+  emit_bug_reporting_address ();
 }
 
 int
diff --git a/src/diff.c b/src/diff.c
index f46aa55..b0ad81b 100644
--- a/src/diff.c
+++ b/src/diff.c
@@ -911,8 +911,6 @@ static char const * const option_help_msgid[] = {
   N_("If --from-file or --to-file is given, there are no restrictions on 
FILES."),
   N_("If a FILE is `-', read standard input."),
   N_("Exit status is 0 if inputs are the same, 1 if different, 2 if trouble."),
-  "",
-  N_("Report bugs to <address@hidden>."),
   0
 };

@@ -941,6 +939,7 @@ usage (void)
          printf ("  %s\n" + 2 * (*msg != ' ' && *msg != '-'), msg);
        }
     }
+  emit_bug_reporting_address ();
 }

 /* Set VAR to VALUE, reporting an OPTION error if this is a
diff --git a/src/diff3.c b/src/diff3.c
index 466f878..d70b3fc 100644
--- a/src/diff3.c
+++ b/src/diff3.c
@@ -453,10 +453,10 @@ usage (void)
       printf ("  %s\n", _(*p));
     else
       putchar ('\n');
-  printf ("\n%s\n%s\n\n%s\n",
+  printf ("\n%s\n%s\n",
          _("If a FILE is `-', read standard input."),
-         _("Exit status is 0 if successful, 1 if conflicts, 2 if trouble."),
-         _("Report bugs to <address@hidden>."));
+         _("Exit status is 0 if successful, 1 if conflicts, 2 if trouble."));
+  emit_bug_reporting_address ();
 }
 
 /* Combine the two diffs together into one.
diff --git a/src/sdiff.c b/src/sdiff.c
index b09b767..d44ffcb 100644
--- a/src/sdiff.c
+++ b/src/sdiff.c
@@ -223,10 +223,10 @@ usage (void)
       printf ("  %s\n", _(*p));
     else
       putchar ('\n');
-  printf ("\n%s\n%s\n\n%s\n",
+  printf ("\n%s\n%s\n",
          _("If a FILE is `-', read standard input."),
-         _("Exit status is 0 if inputs are the same, 1 if different, 2 if 
trouble."),
-         _("Report bugs to <address@hidden>."));
+         _("Exit status is 0 if inputs are the same, 1 if different, 2 if 
trouble."));
+  emit_bug_reporting_address ();
 }

 /* Clean up after a signal or other failure.  This function is
--
1.6.5.3.370.g5b5a93


>From b60091684ac415bcc6efaaedc42d31dedd378a75 Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 16 Nov 2009 08:58:54 +0100
Subject: [PATCH 04/10] maint: no longer define *_FILENO constants

* src/system.h (STDIN_FILENO, STDOUT_FILENO, STDERR_FILENO):
Remove definitions.  Now guaranteed by gnulib.
---
 src/system.h |    9 ---------
 1 files changed, 0 insertions(+), 9 deletions(-)

diff --git a/src/system.h b/src/system.h
index 47e0ec9..2ba53a4 100644
--- a/src/system.h
+++ b/src/system.h
@@ -49,15 +49,6 @@
 #endif

 #include <unistd.h>
-#ifndef STDIN_FILENO
-# define STDIN_FILENO 0
-#endif
-#ifndef STDOUT_FILENO
-# define STDOUT_FILENO 1
-#endif
-#ifndef STDERR_FILENO
-# define STDERR_FILENO 2
-#endif

 #include <fcntl.h>
 #include <time.h>
--
1.6.5.3.370.g5b5a93


>From 9b0a630024092f50d6c94d9d033c02dd5bdd6a5b Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 16 Nov 2009 09:01:57 +0100
Subject: [PATCH 05/10] maint: define/use PROGRAM_NAME and AUTHORS; use 
propername module

* bootstrap.conf (gnulib_modules): Add propername.
* src/cmp.c (PROGRAM_NAME, AUTHORS): Define.
(main): Use them in use of version_etc.
* src/diff.c (PROGRAM_NAME, AUTHORS, main): Likewise.
* src/diff3.c (PROGRAM_NAME, AUTHORS, main): Likewise.
* src/sdiff.c (PROGRAM_NAME, AUTHORS, main): Likewise.
* src/system.h: Include "propername.h".
---
 bootstrap.conf |    1 +
 src/cmp.c      |   14 +++++++++-----
 src/diff.c     |   15 ++++++++++++---
 src/diff3.c    |   10 ++++++++--
 src/sdiff.c    |   10 ++++++++--
 src/system.h   |    1 +
 6 files changed, 39 insertions(+), 12 deletions(-)

diff --git a/bootstrap.conf b/bootstrap.conf
index 5f51731..e5e8ca3 100644
--- a/bootstrap.conf
+++ b/bootstrap.conf
@@ -49,6 +49,7 @@ maintainer-makefile
 mbrtowc
 mkstemp
 progname
+propername
 regex
 sh-quote
 stat-macros
diff --git a/src/cmp.c b/src/cmp.c
index 18056a6..0111e37 100644
--- a/src/cmp.c
+++ b/src/cmp.c
@@ -35,6 +35,13 @@
 #include <xalloc.h>
 #include <xstrtol.h>

+/* The official name of this program (e.g., no `g' prefix).  */
+#define PROGRAM_NAME "cmp"
+
+#define AUTHORS \
+  proper_name_utf8 ("Torbjorn Granlund", "Torbj\303\266rn Granlund"), \
+  proper_name ("David MacKenzie")
+
 #if defined LC_MESSAGES && ENABLE_NLS
 # define hard_locale_LC_MESSAGES hard_locale (LC_MESSAGES)
 #else
@@ -234,11 +241,8 @@ main (int argc, char **argv)
        break;

       case 'v':
-       /* TRANSLATORS: Please translate the second "o" in "Torbjorn
-          Granlund" to an o-with-umlaut (U+00F6, LATIN SMALL LETTER O
-          WITH DIAERESIS) if possible.  */
-       version_etc (stdout, "cmp", PACKAGE_NAME, PACKAGE_VERSION,
-                    _("Torbjorn Granlund"), "David MacKenzie", (char *) 0);
+       version_etc (stdout, PROGRAM_NAME, PACKAGE_NAME, PACKAGE_VERSION,
+                    AUTHORS, (char *) NULL);
        check_stdout ();
        return EXIT_SUCCESS;

diff --git a/src/diff.c b/src/diff.c
index b0ad81b..708d892 100644
--- a/src/diff.c
+++ b/src/diff.c
@@ -38,6 +38,16 @@
 #include <version-etc.h>
 #include <xalloc.h>

+/* The official name of this program (e.g., no `g' prefix).  */
+#define PROGRAM_NAME "diff"
+
+#define AUTHORS \
+  proper_name ("Paul Eggert"), \
+  proper_name ("Mike Haertel"), \
+  proper_name ("David Hayes"), \
+  proper_name ("Richard Stallman"), \
+  proper_name ("Len Tower")
+
 #ifndef GUTTER_WIDTH_MINIMUM
 # define GUTTER_WIDTH_MINIMUM 3
 #endif
@@ -467,9 +477,8 @@ main (int argc, char **argv)
          break;

        case 'v':
-         version_etc (stdout, "diff", PACKAGE_NAME, PACKAGE_VERSION,
-                      "Paul Eggert", "Mike Haertel", "David Hayes",
-                      "Richard Stallman", "Len Tower", (char *) NULL);
+         version_etc (stdout, PROGRAM_NAME, PACKAGE_NAME, PACKAGE_VERSION,
+                      AUTHORS, (char *) NULL);
          check_stdout ();
          return EXIT_SUCCESS;

diff --git a/src/diff3.c b/src/diff3.c
index d70b3fc..f682745 100644
--- a/src/diff3.c
+++ b/src/diff3.c
@@ -34,6 +34,12 @@
 #include <version-etc.h>
 #include <xalloc.h>

+/* The official name of this program (e.g., no `g' prefix).  */
+#define PROGRAM_NAME "diff3"
+
+#define AUTHORS \
+  proper_name ("Randy Smith")
+
 /* Internal data structures and macros for the diff3 program; includes
    data structures for both diff3 diffs and normal diffs.  */

@@ -273,8 +279,8 @@ main (int argc, char **argv)
          strip_trailing_cr = true;
          break;
        case 'v':
-         version_etc (stdout, "diff3", PACKAGE_NAME, PACKAGE_VERSION,
-                      "Randy Smith", (char *) 0);
+         version_etc (stdout, PROGRAM_NAME, PACKAGE_NAME, PACKAGE_VERSION,
+                      AUTHORS, (char *) NULL);
          check_stdout ();
          return EXIT_SUCCESS;
        case DIFF_PROGRAM_OPTION:
diff --git a/src/sdiff.c b/src/sdiff.c
index d44ffcb..07ac0cb 100644
--- a/src/sdiff.c
+++ b/src/sdiff.c
@@ -35,6 +35,12 @@
 #include <version-etc.h>
 #include <xalloc.h>

+/* The official name of this program (e.g., no `g' prefix).  */
+#define PROGRAM_NAME "sdiff"
+
+#define AUTHORS \
+  proper_name ("Thomas Lord")
+
 /* Size of chunks read from files which must be parsed into lines.  */
 #define SDIFF_BUFSIZE ((size_t) 65536)

@@ -526,8 +532,8 @@ main (int argc, char *argv[])
          break;

        case 'v':
-         version_etc (stdout, "sdiff", PACKAGE_NAME, PACKAGE_VERSION,
-                      "Thomas Lord", (char *) 0);
+         version_etc (stdout, PROGRAM_NAME, PACKAGE_NAME, PACKAGE_VERSION,
+                      AUTHORS, (char *) NULL);
          check_stdout ();
          return EXIT_SUCCESS;

diff --git a/src/system.h b/src/system.h
index 2ba53a4..3e37bbc 100644
--- a/src/system.h
+++ b/src/system.h
@@ -134,6 +134,7 @@ int strcasecmp (char const *, char const *);
 #endif
 
 #include <intprops.h>
+#include "propername.h"

 /* Type used for fast comparison of several bytes at a time.  */

--
1.6.5.3.370.g5b5a93


>From 8fbbf26925a6e2183be8211fb82a6eb518229a38 Mon Sep 17 00:00:00 2001
From: Eric Blake <address@hidden>
Date: Thu, 12 Nov 2009 08:17:56 -0700
Subject: [PATCH 06/10] build: avoid link failure when libsigsegv is used

* src/Makefile.am (LDADD): Link against LIBSIGSEGV.
---
 src/Makefile.am |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

diff --git a/src/Makefile.am b/src/Makefile.am
index 00f4f09..859a469 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -23,7 +23,7 @@ localedir = $(datadir)/locale

 AM_CPPFLAGS = -I../lib -I$(top_srcdir)/lib

-LDADD = ../lib/libdiffutils.a $(LIBINTL)
+LDADD = ../lib/libdiffutils.a $(LIBINTL) $(LIBSIGSEGV)
 diff_LDADD = $(LDADD) $(LIB_CLOCK_GETTIME)

 cmp_SOURCES = cmp.c
--
1.6.5.3.370.g5b5a93


>From 5f93400251fb7be08fa03ef7c2dd78b4850481ba Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 16 Nov 2009 17:15:38 +0100
Subject: [PATCH 07/10] admin: ignore all of gnulib-tests

* .gitignore: Add gnulib-tests
---
 .gitignore |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

diff --git a/.gitignore b/.gitignore
index 78b4daa..e093a1c 100644
--- a/.gitignore
+++ b/.gitignore
@@ -12,6 +12,7 @@
 /doc/diff.info
 /doc/stamp-vti
 /doc/version.texi
+/gnulib-tests
 /gnulib-tests/.gitignore
 /gnulib-tests/locale/
 /gnulib-tests/uniwidth/
--
1.6.5.3.370.g5b5a93


>From a401664d47f17b1c7497c2a251b073de105cdbec Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 16 Nov 2009 21:41:38 +0100
Subject: [PATCH 08/10] build: let automake generate better man-installation 
rules

* man/Makefile.am (dist_man1_MANS): Rename from dist_man_MANS,
to enable better automake-generated installation rules.
---
 man/Makefile.am |    6 +++---
 1 files changed, 3 insertions(+), 3 deletions(-)

diff --git a/man/Makefile.am b/man/Makefile.am
index 6f03ead..8c8b407 100644
--- a/man/Makefile.am
+++ b/man/Makefile.am
@@ -15,8 +15,8 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.

-dist_man_MANS =        cmp.1 diff.1 diff3.1 sdiff.1
-MAINTAINERCLEANFILES = $(dist_man_MANS)
+dist_man1_MANS = cmp.1 diff.1 diff3.1 sdiff.1
+MAINTAINERCLEANFILES = $(dist_man1_MANS)

 S = $(top_srcdir)/src
 cmp.1: $S/cmp.c
@@ -25,7 +25,7 @@ diff3.1: $S/diff3.c
 sdiff.1: $S/sdiff.c

 # Depend on configure.ac to get version number changes.
-$(dist_man_MANS): $(top_srcdir)/configure.ac
+$(dist_man1_MANS): $(top_srcdir)/configure.ac
        base=`expr $@ : '\(.*\).1'` && \
          (echo '[NAME]' && sed 's@/\* *@@; s/-/\\-/; q' $S/$$base.c) | \
          $(HELP2MAN) -i - -S '$(PACKAGE) $(VERSION)' ../src/$$base | \
--
1.6.5.3.370.g5b5a93


>From 2514ec69733ac7491cd80b9e4710034e6218a134 Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 16 Nov 2009 21:49:37 +0100
Subject: [PATCH 09/10] maint: hide build commands behind $(AM_V_GEN)

* src/Makefile.am (paths.h): Use $(AM_V_GEN), and split a long line.
* man/Makefile.am ($(dist_man1_MANS)): Use $(AM_V_GEN) here, too.
---
 man/Makefile.am |    2 +-
 src/Makefile.am |    8 +++++---
 2 files changed, 6 insertions(+), 4 deletions(-)

diff --git a/man/Makefile.am b/man/Makefile.am
index 8c8b407..d3fc507 100644
--- a/man/Makefile.am
+++ b/man/Makefile.am
@@ -26,7 +26,7 @@ sdiff.1: $S/sdiff.c

 # Depend on configure.ac to get version number changes.
 $(dist_man1_MANS): $(top_srcdir)/configure.ac
-       base=`expr $@ : '\(.*\).1'` && \
+       $(AM_V_GEN)base=`expr $@ : '\(.*\).1'` && \
          (echo '[NAME]' && sed 's@/\* *@@; s/-/\\-/; q' $S/$$base.c) | \
          $(HELP2MAN) -i - -S '$(PACKAGE) $(VERSION)' ../src/$$base | \
          sed 's/^\.B info .*/.B info diff/' >$@
diff --git a/src/Makefile.am b/src/Makefile.am
index 859a469..84f330d 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -36,7 +36,9 @@ diff_SOURCES = \
 MOSTLYCLEANFILES = paths.h paths.ht

 cmp.$(OBJEXT) diff3.$(OBJEXT) diff.$(OBJEXT) sdiff.$(OBJEXT): paths.h
+
+gdiff = `echo diff|sed '$(transform)'`
+BUILT_SOURCES = paths.h
 paths.h:
-       (echo '#define DEFAULT_DIFF_PROGRAM "'`echo diff|sed '$(transform)'`'"' 
&& \
-        echo '#define LOCALEDIR "$(localedir)"') >address@hidden
-       mv address@hidden $@
+       $(AM_V_GEN)(echo '#define DEFAULT_DIFF_PROGRAM "'$(gdiff)'"' && \
+         echo '#define LOCALEDIR "$(localedir)"') >address@hidden && mv 
address@hidden $@
--
1.6.5.3.370.g5b5a93


>From 6be63587089728ac8dd140781ae586fb314d9ac4 Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Wed, 18 Nov 2009 07:41:04 +0100
Subject: [PATCH 10/10] build: update gnulib submodule to latest

---
 gnulib |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

diff --git a/gnulib b/gnulib
index 6963723..6038ee4 160000
--- a/gnulib
+++ b/gnulib
@@ -1 +1 @@
-Subproject commit 69637233ce151566c1a861bce77e1ca32305638e
+Subproject commit 6038ee4b827caaf05fa37dbb2304fedb9d0cd6c7
--
1.6.5.3.370.g5b5a93




reply via email to

[Prev in Thread] Current Thread [Next in Thread]